<template>
  <div class="q-px-md">
    <q-btn
      text-color="blue-grey-4"
      color="grey-3"
      unelevated
      round
    >
      <q-avatar
        v-if="avatar"
        size="42px"
      >
        <img :src="generateDownloadURL('usuarios', avatar)">
      </q-avatar>

      <q-icon
        v-else
        name="fas fa-user-alt"
      />

      <q-menu
        content-class="bg-secondary text-primary"
        content-style="min-width: 350px"
        transition-show="jump-up"
        transition-hide="jump-down"
        anchor="bottom left"
        self="top left"
        :offset="[0, 13]"
        max-width="500px"
        auto-close
      >
        <div class="row no-wrap q-px-sm">
          <div class="column fit">
            <q-list
              separator
              padding
            >
              <q-item
                :active="$route.path === '/compositions'"
                active-class="text-bold"
                to="/compositions"
                clickable
              >
                <q-item-section side>
                  <q-icon
                    name="las la-home"
                    color="primary"
                  />
                </q-item-section>

                <q-item-section>
                  Dashboard
                </q-item-section>
              </q-item>

              <q-item
                :to="{ name: 'profile', params: { userId } }"
                :active="$route.path === '/profile'"
                active-class="text-bold"
                clickable
              >
                <q-item-section side>
                  <q-icon
                    name="las la-user-circle"
                    color="primary"
                  />
                </q-item-section>

                <q-item-section>
                  Meu Perfil
                </q-item-section>
              </q-item>

              <q-item
                to="/auth/logout"
                clickable
              >
                <q-item-section side>
                  <q-icon
                    name="las la-sign-out-alt"
                    color="primary"
                  />
                </q-item-section>

                <q-item-section>
                  Sair
                </q-item-section>
              </q-item>
            </q-list>
          </div>

          <q-separator
            class="q-mx-sm"
            vertical
            inset
          />

          <div class="column items-center q-px-md q-pt-lg">
            <q-avatar size="72px">
              <img
                v-if="avatar"
                :src="generateDownloadURL('usuarios', avatar)"
              >

              <q-icon
                v-else
                size="72px"
                name="fas fa-user-circle"
              />
            </q-avatar>

            <div
              class="full-width text-center text-body2 text-bold no-wrap q-py-md"
              v-text="fullname"
            />
          </div>
        </div>
      </q-menu>
    </q-btn>
  </div>
</template>

<script>
import { GenerateDownloadURLMixin } from '../../mixin/generate-download-url'

export default {
  name: 'MenuProfile',
  mixins: [GenerateDownloadURLMixin],
  computed: {
    userId () {
      return Number(this.$store.state.session.user.id) || null
    },
    avatar () {
      return this.$store.state.session.user.avatar || null
    },
    fullname () {
      const name = this.$store.state.session.user.name.split(' ')

      return `${name.shift() || ''} ${name.pop() || ''}` || 'Admin'
    }
  }
}
</script>
